<template>
  <div class="chat-page">
    <Header
      :isContactsProp="isContacts"
      @handleContacts="value => isContacts = value"
    />

    <q-drawer
      show-if-above
      v-model="isContacts"
      side="left"
      bordered
      :mini="!isContacts || isMiniContacts"
      @click.capture="drawerClick"
      :width="200"
      :mini-width="62"
      :breakpoint="500"
      class="drawer"
    >
      <template #mini>
        <ContactList :users="users" onlyAvatar />
      </template>

      <ContactList :users="users" />

      <div class="q-mini-drawer-hide absolute" style="top: 15px; right: -17px">
        <q-btn
          dense
          round
          unelevated
          color="accent"
          icon="chevron_left"
          @click="isMiniContacts = true"
        />
      </div>
    </q-drawer>

    <q-page-container class="main-page">
      <q-splitter
        v-model="splitterModel"
        horizontal
        :limits="[30, 70]"
        before-class="overflow-hidden"
        after-class="overflow-hidden"
        style="height: 100%"
      >

        <template v-slot:before>
          <ChatBlock :user="users[1]" />
        </template>

        <template v-slot:separator>
          <IconBase iconName="separator" class="separator">
            <separator />
          </IconBase>
        </template>

        <template v-slot:after>
          <ChatBlock :user="users[0]" />
        </template>
      </q-splitter>
    </q-page-container>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api'
import Header from 'components/Header.vue'
import Input from 'components/Input.vue'
import NameChat from 'components/NameChat.vue'
import ChatBlock from './ChatBlock.vue'
import ContactList from 'components/ContactList.vue'
import separator from 'components/icons/separator.vue'
import { User } from 'pages/auth/Auth.vue'

export default defineComponent({
  name: 'Chat',
  components: {
    Header,
    Input,
    NameChat,
    ChatBlock,
    ContactList,
    separator
  },

  // beforeCreate () {
  //   if (!IsUser(this.$store.state.main.user)) this.$router.push('/')
  // },

  setup (props, ctx) {
    const isContacts = ref(true)
    const isMiniContacts = ref(false)
    const splitterModel = ref(50)
    let users: User[] = []

    users = users.concat(ctx.root.$store.state.main.user, ctx.root.$store.state.main.users)

    function drawerClick (e) {
      if (isMiniContacts.value) {
        isMiniContacts.value = false
        e.stopPropagation()
      }
    }

    return {
      isContacts,
      isMiniContacts,
      splitterModel,
      drawerClick,
      users
    }
  }
})
</script>

<style lang="scss" scoped>
@import '../../css/variables';

$indent: 10px;

.chat-page {
  height: 100vh;
  overflow: hidden;
}

.main-page {
  height: 100%;
}

.separator {
  width: 30px;
  height: 30px;
}
</style>
